package java.sql;

import java.time.Instant;
import java.time.LocalDateTime;
import java.util.Date;

public class Timestamp extends Date
{
    private int nanos;
    static final long serialVersionUID = 2745179027874758501L;
    private static final int MILLIS_PER_SECOND = 1000;
    
    @Deprecated
    public Timestamp(int year, int month, int date, int hrs, int min, int sec, int nanos) {
        super(year, month, date, hrs, min, sec);
        if (nanos > 999999999 || nanos < 0) {
            throw new IllegalArgumentException("nanos > 999999999 or < 0");
        }
        this.nanos = nanos;
        return;
    }
    
    public Timestamp(long n) {
        super(n / 1000L * 1000L);
        this.nanos = (int)(n % 1000L * 1000000L);
        if (this.nanos < 0) {
            this.nanos += 1000000000;
            super.setTime((n / 1000L - 1L) * 1000L);
        }
    }
    
    @Override
    public void setTime(long n) {
        super.setTime(n / 1000L * 1000L);
        this.nanos = (int)(n % 1000L * 1000000L);
        if (this.nanos < 0) {
            this.nanos += 1000000000;
            super.setTime((n / 1000L - 1L) * 1000L);
        }
    }
    
    @Override
    public long getTime() {
        return super.getTime() + (long)(this.nanos / 1000000);
    }
    
    public static Timestamp valueOf(String trim) {
        int int1 = 0;
        int int2 = 0;
        int int3 = 0;
        int int4 = 0;
        String s = "Timestamp format must be yyyy-mm-dd hh:mm:ss[.fffffffff]";
        String s2 = "000000000";
        if (trim == null) {
            throw new IllegalArgumentException("null string");
        }
        trim = trim.trim();
        int index = trim.indexOf(32);
        if (index > 0) {
            String substring = trim.substring(0, index);
            String substring2 = trim.substring(index + 1);
            int index2 = substring.indexOf(45);
            int index3 = substring.indexOf(45, index2 + 1);
            if (substring2 == null) {
                throw new IllegalArgumentException(s);
            }
            int index4 = substring2.indexOf(58);
            int index5 = substring2.indexOf(58, index4 + 1);
            int index6 = substring2.indexOf(46, index5 + 1);
            boolean n = false;
            if (index2 > 0 && index3 > 0 && index3 < substring.length() - 1) {
                String substring3 = substring.substring(0, index2);
                String substring4 = substring.substring(index2 + 1, index3);
                String substring5 = substring.substring(index3 + 1);
                if (substring3.length() == 4 && substring4.length() >= 1 && substring4.length() <= 2 && substring5.length() >= 1 && substring5.length() <= 2) {
                    int1 = Integer.parseInt(substring3);
                    int2 = Integer.parseInt(substring4);
                    int3 = Integer.parseInt(substring5);
                    if (int2 >= 1 && int2 <= 12 && int3 >= 1 && int3 <= 31) {
                        n = true;
                    }
                }
            }
            if (n == 0) {
                throw new IllegalArgumentException(s);
            }
            if ((index4 > 0 & index5 > 0 & index5 < substring2.length() - 1)) {
                int int5 = Integer.parseInt(substring2.substring(0, index4));
                int int6 = Integer.parseInt(substring2.substring(index4 + 1, index5));
                int n2;
                if ((index6 > 0 & index6 < substring2.length() - 1)) {
                    n2 = Integer.parseInt(substring2.substring(index5 + 1, index6));
                    String substring6 = substring2.substring(index6 + 1);
                    if (substring6.length() > 9) {
                        throw new IllegalArgumentException(s);
                    }
                    if (!Character.isDigit(substring6.charAt(0))) {
                        throw new IllegalArgumentException(s);
                    }
                    int4 = Integer.parseInt(substring6 + s2.substring(0, 9 - substring6.length()));
                }
                else {
                    if (index6 > 0) {
                        throw new IllegalArgumentException(s);
                    }
                    n2 = Integer.parseInt(substring2.substring(index5 + 1));
                }
                return new Timestamp(int1 - 1900, int2 - 1, int3, int5, int6, n2, int4);
            }
            else {
                throw new IllegalArgumentException(s);
            }
        }
        else {
            throw new IllegalArgumentException(s);
        }
    }
    
    @Override
    public String toString() {
        int n = super.getYear() + 1900;
        int n2 = super.getMonth() + 1;
        int date = super.getDate();
        int hours = super.getHours();
        int minutes = super.getMinutes();
        int seconds = super.getSeconds();
        String s = "000000000";
        String s2 = "0000";
        String str;
        if (n < 1000) {
            String string = "" + n;
            str = s2.substring(0, 4 - string.length()) + string;
        }
        else {
            str = "" + n;
        }
        String str2;
        if (n2 < 10) {
            str2 = "0" + n2;
        }
        else {
            str2 = Integer.toString(n2);
        }
        String str3;
        if (date < 10) {
            str3 = "0" + date;
        }
        else {
            str3 = Integer.toString(date);
        }
        String str4;
        if (hours < 10) {
            str4 = "0" + hours;
        }
        else {
            str4 = Integer.toString(hours);
        }
        String str5;
        if (minutes < 10) {
            str5 = "0" + minutes;
        }
        else {
            str5 = Integer.toString(minutes);
        }
        String str6;
        if (seconds < 10) {
            str6 = "0" + seconds;
        }
        else {
            str6 = Integer.toString(seconds);
        }
        String str7;
        if (this.nanos == 0) {
            str7 = "0";
        }
        else {
            String string2 = Integer.toString(this.nanos);
            String string3 = s.substring(0, 9 - string2.length()) + string2;
            char[] array = new char[string3.length()];
            string3.getChars(0, string3.length(), array, 0);
            int n3;
            for (n3 = 8; array[n3] == '0'; --n3) {}
            str7 = new String(array, 0, n3 + 1);
        }
        StringBuffer o = new StringBuffer(20 + str7.length());
        o.append(str);
        o.append("-");
        o.append(str2);
        o.append("-");
        o.append(str3);
        o.append(" ");
        o.append(str4);
        o.append(":");
        o.append(str5);
        o.append(":");
        o.append(str6);
        o.append(".");
        o.append(str7);
        return o.toString();
    }
    
    public int getNanos() {
        return this.nanos;
    }
    
    public void setNanos(int nanos) {
        if (nanos > 999999999 || nanos < 0) {
            throw new IllegalArgumentException("nanos > 999999999 or < 0");
        }
        this.nanos = nanos;
        return;
    }
    
    public boolean equals(Timestamp obj) {
        return super.equals(obj) && this.nanos == obj.nanos;
    }
    
    @Override
    public boolean equals(Object o) {
        return o instanceof Timestamp && this.equals((Timestamp)o);
    }
    
    public boolean before(Timestamp timestamp) {
        return this.compareTo(timestamp) < 0;
    }
    
    public boolean after(Timestamp timestamp) {
        return this.compareTo(timestamp) > 0;
    }
    
    public int compareTo(Timestamp timestamp) {
        long time = this.getTime();
        long time2 = timestamp.getTime();
        int n = (time < time2) ? -1 : ((time == time2) ? 0 : 1);
        if (n == 0) {
            if (this.nanos > timestamp.nanos) {
                return 1;
            }
            if (this.nanos < timestamp.nanos) {
                return -1;
            }
        }
        return n;
    }
    
    @Override
    public int compareTo(Date date) {
        if ((date instanceof Timestamp)) {
            return this.compareTo((Timestamp)date);
        }
        return this.compareTo(new Timestamp(date.getTime()));
    }
    
    @Override
    public int hashCode() {
        return super.hashCode();
    }
    
    public static Timestamp valueOf(LocalDateTime localDateTime) {
        return new Timestamp(localDateTime.getYear() - 1900, localDateTime.getMonthValue() - 1, localDateTime.getDayOfMonth(), localDateTime.getHour(), localDateTime.getMinute(), localDateTime.getSecond(), localDateTime.getNano());
    }
    
    public LocalDateTime toLocalDateTime() {
        return LocalDateTime.of(this.getYear() + 1900, this.getMonth() + 1, this.getDate(), this.getHours(), this.getMinutes(), this.getSeconds(), this.getNanos());
    }
    
    public static Timestamp from(Instant instant) {
        try {
            Timestamp timestamp = new Timestamp(instant.getEpochSecond() * 1000L);
            timestamp.nanos = instant.getNano();
            return timestamp;
        }
        catch (ArithmeticException cause) {
            throw new IllegalArgumentException(cause);
        }
    }
    
    @Override
    public Instant toInstant() {
        return Instant.ofEpochSecond(super.getTime() / 1000L, (long)this.nanos);
    }
}
